Subject: Re: [PATCH] merge-file: warn for implicit 'myers' algorithm

From: Junio C Hamano <[email-masked]>
Date: Fri, 05 Jul 2024 23:06:48 -0700

Elijah Newren <[email-masked]> writes:

> The previous discussions felt to me like we were moving towards
> consensus, but while I found that encouraging since I think histogram
> would eventually be a better default, I did not make any actual
> proposals and try to push further towards consensus because there are
> a couple known issues that I think should be fixed before we consider
> flipping the default.

OK.

> I have some work-in-progress that was put on
> the backburner a few years ago that I would like to pick up again, and
> if successful, investigate how much that helps general cases in a
> format that can help people make educated decisions, and then again
> float the idea of changing the default.

Sounds like a good plan.

> If consensus is reached, then
> we'd change the default across the board -- diff/log/merge-file/etc.
> rather than just the somewhat rarely used merge-file.  

Everybody uses diff.c::diff_algorithm somehow, will be affected by
the diff.algorithm configuration variable, and everybody should
honor "--diff-algorithm=<choice>" command line option to override?

It sounds like a great plan.  If ort for some reason performs better
with histogram while format-patch works better with minimal, we
could extend the configuration system to make diff.<cmd>.algorithm
override the more generic diff.algorithm and do similarly silly
things.  We may want to also teach the diff plumbing commands to
ignore diff.algorithm for better reproducibility but we may need to
wait for Git 3.0 to do that.

> At least,
> that's my current plan in this area; if others think I should
> investigate things in a different order or would like to see
> additional steps planned into this journey, please do let me know.

Thanks.